/*
 * HTMLHelp.java
 *
 * Created on 19. Januar 2006, 17:54
 */

package logicsim;


import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.border.*;
import java.awt.geom.*;
import java.net.URL;
import java.io.*;

/**
 *
 * @author  atetzl
 */
public class HTMLHelp extends javax.swing.JFrame implements java.awt.event.ActionListener {
    Toolkit toolkit = Toolkit.getDefaultToolkit();
    String lang;
    
    /** Creates new form HTMLHelp */
    public HTMLHelp(String lang) {
        this.lang=lang;
        Dimension scrSize;
        int width=800, height=600;
        
        getContentPane().setLayout(new BorderLayout(0,0));
        initComponents();
        this.enableEvents(AWTEvent.MOUSE_EVENT_MASK);
        
        scrSize = toolkit.getScreenSize();
        setLocation( ( scrSize.width / 2 ) - ( width / 2 ),
                ( scrSize.height / 2 ) - ( height / 2 ) );
        setSize( width, height );
        this.setTitle("LogicSim Help");
        this.show();
        
        try {
            String url=null;
            if (LSFrame.isApplet) {
                // TODO: applet shows only english docs
                url=LSFrame.applet.getCodeBase()+"doc/english.html";
                System.out.println(url);
            } else {
                File f = new File("doc");
                File[] files=f.listFiles();
                url=new File("doc/english.html").getAbsolutePath();
                // Anleitung in der eingestellten Sprache finden
                for (int i=0; i<files.length; i++) {
                    if (files[i].getName().startsWith(lang) && files[i].getName().endsWith(".html")) {
                        url=files[i].getAbsolutePath();
                    }
                }
                
                url=url.replaceAll("\\\\", "/");
                url="file:///"+url;
                url=url.replaceAll(" ", "%20");
            }
            jTextPane1.setPage(url);
        } catch (Exception ex) {
            ex.printStackTrace();
            this.hide();
            this.dispose();
        }
        
    }
    
    protected void processMouseEvent(MouseEvent e) {
        super.processMouseEvent(e);
        int id = e.getID();
        if (id==MouseEvent.MOUSE_CLICKED) {
            this.hide();
            this.dispose();
        }
    }
    
    protected void processWindowEvent(WindowEvent e) {
        //super.processWindowEvent(e);
        if (e.getID() == WindowEvent.WINDOW_CLOSING) {
            this.dispose();
        }
    }
    
    public void actionPerformed(ActionEvent e) {
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        jButton_ok = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        jTextPane1 = new javax.swing.JTextPane();

        jButton_ok.setText("OK");
        jButton_ok.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                jButton_okActionPerformed(evt);
            }
        });

        getContentPane().add(jButton_ok, java.awt.BorderLayout.SOUTH);

        jTextPane1.setEditable(false);
        jTextPane1.setMinimumSize(new java.awt.Dimension(400, 300));
        jScrollPane1.setViewportView(jTextPane1);

        getContentPane().add(jScrollPane1, java.awt.BorderLayout.CENTER);

        pack();
    }// </editor-fold>//GEN-END:initComponents
    
    private void jButton_okActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_jButton_okActionPerformed
        this.dispose();
        this.hide();
    }//GEN-LAST:event_jButton_okActionPerformed
    
    
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton jButton_ok;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JTextPane jTextPane1;
    // End of variables declaration//GEN-END:variables
    
}
